#<profile4xi profile = "02" />  
# -------------------------------------------------------------------------------------------------
#<program4xi program = "value4xi.py">
#<abstract4xi abstract = "provides class Value4Xi"/>
#<refer4xi reference = "managers.py"/> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Value4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import weakref
import array
import queue
from traceback import format_exc
import copyreg
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
try:                             # Source ones
    from multiprocessing.managers import Value
except:
    print("value4xi.py: *** failed in from multiprocessing.managers import Value ***")   
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from examine4xi import examine4xi 
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
#"
#/>



# =================================================================================================
#<class4xi class = "Value4Xi" base = "object" child = "None" synopsis = "used in managers to register values" usage = "
#   managers.py 
#       SyncManager.register('Value', Value, ValueProxy)
#   syncmanager4xi.py:
#       SyncManager4Xi.register('Value4Xi', Value4Xi, ValueProxy4Xi)
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# =================================================================================================
class Value4Xi(object):
    '''
    Value4Xi class: used in managers to register values
    '''

    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('get',
                 'set',
                 'sense',
                 'reason',
                 'ace')          
    #"
    #/>
    
                
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Value4Xi" usage = "initializes Value4Xi">                            
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self, typecode, value, lock=True):
        '''
        Value4Xi method __init__: initializes Value4Xi
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------  
        class2print = "Value4Xi"
        method2print = "__init__"
        
        message2print = "{started" + "; init-of-Value4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                        
        message2print = "{borning" + "; value2xi-of-Value4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
                
        message2print = "{passed" + "; typecode-passed-to-Value4Xi: " + str(typecode) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
                
        message2print = "{passed" + "; value-passed-to-Value4Xi: " + str(value) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
                
        message2print = "{passed" + "; lock-passed-to-Value4Xi: " + str(lock) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
                           
        if examine4xi(class2print, method2print):   
        
            # -------------------------------------------------------------------------------------    
            # StepOriginal
            # -------------------------------------------------------------------------------------             
            message2print = "{(Step 2/6b) performing" + "; init-of-Value-performing-by-init-of-Value4Xi: " + str(Value.__init__)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                             
            Value.__init__(self, typecode, value, lock)
            
            
        else:    
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------           
            self._typecode = typecode
            
            message2print = "{set" + "; typecode-of-value2xi-set-by-Value4Xi to: " + str(self._typecode)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                            
                            
                    
            self._value = value
            
            message2print = "{set" + "; value-of-value2xi-set-by-Value4Xi to: " + str(self._value)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
               
            # -------------------------------------------------------------------------------------    
            #
            # ------------------------------------------------------------------------------------- 
            message2print = "{activated" + "; value2xi-of-Value4Xi-activated: " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                     
            message2print = "{returning" + "; init-of-Value4Xi-returning: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 

    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-of-Value4Xi" usage = "returns Value">                           
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------    
    def get(self):
        '''
        Value4Xi method get: returns Value 
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------  
             
        class2print = "Value4Xi"
        method2print = "get"
        
        message2print = "{started" + "; get-of-Value4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    

        if examine4xi(class2print, method2print):  
        
            # -------------------------------------------------------------------------------------    
            # StepOriginal
            # -------------------------------------------------------------------------------------             
            message2print = "{(Step 2/6b) performing" + "; get-of-Value-performing-by-get-of-Value4Xi: " + str(Value.get)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                             
            return Value.get(self)
           
            
        else:                        
        
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------          
            message2print = "{returning" + "; value-of-value2xi-returning-by-get-of-Value4Xi: " + str(self._value) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
                                    
            
            return self._value        
    #</methodize4xi>
            
        
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-of-Value4Xi" usage = "sets Value">                            
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------    
    def set(self, value):
        '''
        Value4Xi method set: sets Value
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------  
             
        class2print = "Value4Xi"
        method2print = "set"
        
        
        message2print = "{started" + "; set-of-Value4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
    

        message2print = "{passed" + "; value-passed-to-set-of-Value4Xi: " + str(value) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                        
        
        if examine4xi(class2print, method2print):  
        
            # -------------------------------------------------------------------------------------    
            # StepOriginal
            # -------------------------------------------------------------------------------------             
            message2print = "{(Step 2/6b) performing" + "; set-of-Value-performing-by-set-of-Value4Xi: " + str(Value.set)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                             
            Value.set(self, value)
           
            
        else:            
        
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------          
    
            self._value = value    
            
            
            message2print = "{set" + "; value-of-value2xi-set-by-Value4Xi to: " + str(self._value)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
               
            
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------
            message2print = "{returning" + "; set-of-Value4Xi-returning: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                                    
                
    #</methodize4xi>

        
                    
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "repr-of-Value4Xi" usage = "return proxy Value">                             
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------    
    def __repr__(self):
        '''
        Value4Xi method __repr__: return proxy Value
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------  
             
        class2print = "Value4Xi"
        method2print = "__repr__"
         
        message2print = "{started" + "; repr-of-Value4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
    
        if examine4xi(class2print, method2print):  
        
            # -------------------------------------------------------------------------------------    
            # StepOriginal
            # -------------------------------------------------------------------------------------             
            message2print = "{(Step 2/6b) performing" + "; repr-of-Value-performing-by-repr-of-Value4Xi: " + str(Value.__repr__)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                             
            return Value.__repr__(self)
           
            
        else:                        
                   
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------          
            message2print = "{returning" + "; typecode-of-value2xi-returning-by-repr-of-Value4Xi: " + str(self._typecode) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
            
            message2print = "{returning" + "; value-of-value2xi-returning-by-repr-of-Value4Xi: " + str(self._value) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
          
            
            
            return '%s(%r, %r)'%(type(self).__name__, self._typecode, self._value)   
    #</methodize4xi>
             

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    #<note4xi note = "class variable value is defined here because it uses methods get and set"/>
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    value = property(get, set)
    #"
    #/>
           
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Value4Xi" usage = "senses Value4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Value4Xi class objects
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------  

        class2print = 'Value4Xi'
        method2print = 'sense'
        
        
        
        message2print = "{started" + "; sense-of-Value4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
    
   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; Value4Xi-sensing-by-sense-of-Value4Xi: " + str(Value4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                  
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-Value4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['typecode-of-value2xi'] = self._typecode
            kb2xi['value-of-value2xi'] = self._value           
        
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-Value4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                
        
        
      
        message2print = "{sensed" + "; Value4Xi-sensed-by-sense-of-Value4Xi: " + str(Value4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-Value4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                               
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Value4Xi" usage = "reasons Value4Xiclass objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Value4Xiclass objects
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------  

        class2print = 'Value4Xi'
        method2print = 'reason'
        
        
        message2print = "{started" + "; reason-of-Value4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
    
   
    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; Value4Xi-reasoning-by-reason-of-Value4Xi: " + str(Value4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-Value4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                                           
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; Value4Xi-reasoned-by-reason-of-Value4Xi: " + str(Value4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-Value4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                        
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Value4Xi" usage = "aces Value4Xiclass objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Value4Xiclass objects 
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------  

        class2print = 'Value4Xi'
        method2print = 'ace'
        
        
        message2print = "{started" + "; ace-of-Value4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
    
           
         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; Value4Xi-acing-by-ace-of-Value4Xi: " + str(Value4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
                 
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-Value4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; Value4Xi-aced-by-ace-of-Value4Xi: " + str(Value4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-Value4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                        
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   None
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of value4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

